<?php

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $template, $conf, $lang, $im_priority;

include(get_language_filepath('plugin.lang.php', COMONINDEX_PATH));
// +-----------------------------------------------------------------------+
// |                         comments management                           |
// +-----------------------------------------------------------------------+
if (isset($_GET['delete']) and is_numeric($_GET['delete'])
        and !is_adviser()) { // comments deletion
    check_status(ACCESS_ADMINISTRATOR);
    $query = '
DELETE FROM ' . COMMENTS_TABLE . '
  WHERE id=' . $_GET['delete'] . '
;';
    pwg_query($query);
}

if (isset($_GET['validate']) and is_numeric($_GET['validate'])
        and !is_adviser()) { // comments validation
    check_status(ACCESS_ADMINISTRATOR);
    $query = '
UPDATE ' . COMMENTS_TABLE . '
  SET validated = \'true\'
  , validation_date = NOW()
  WHERE id=' . $_GET['validate'] . '
;';
    pwg_query($query);
}
// +-----------------------------------------------------------------------+
// |                        last comments display                          |
// +-----------------------------------------------------------------------+
$conf_comonindex = explode("," , $conf['comonindex']);
$comments = array();
$element_ids = array();
$category_ids = array();
$max_width = 0;
if (!is_admin()) {
    $clauses[] = 'validated="true"';
}
$clauses[] = get_sql_condition_FandF (
    array ('forbidden_categories' => 'category_id',
        'visible_categories' => 'category_id',
        'visible_images' => 'ic.image_id'), '', true);

$query = 'SELECT com.id AS comment_id
   , com.image_id
   , ic.category_id
   , com.author
   , com.date
   , com.content
   , com.id AS comment_id
   , com.validated
   FROM ' . IMAGE_CATEGORY_TABLE . ' AS ic
   INNER JOIN ' . COMMENTS_TABLE . ' AS com
   ON ic.image_id = com.image_id
   WHERE ' . implode(' AND ', $clauses) . '
    GROUP BY comment_id
    ORDER BY date DESC
    LIMIT 0, ' . $conf_comonindex[0];

$query .= ';
    ';
$result = pwg_query($query);
while ($row = mysql_fetch_assoc($result)) {
    array_push($comments, $row);
    array_push($element_ids, $row['image_id']);
    array_push($category_ids, $row['category_id']);
}

if (count($comments) > 0) {
    // retrieving element informations
    $elements = array();
    $query = '
    SELECT id, name, file, path, tn_ext
    FROM ' . IMAGES_TABLE . '
    WHERE id IN (' . implode(', ', $element_ids) . ');
    ';
    $result = pwg_query($query);
    while ($row = mysql_fetch_assoc($result)) {
        $elements[$row['id']] = $row;
    }
    // retrieving category informations
    $query = '
    SELECT id, name, permalink, uppercats
    FROM ' . CATEGORIES_TABLE . '
    WHERE id IN (' . implode(', ', $category_ids) . ');
    ';
    $categories = hash_from_query($query, 'id');

    foreach ($comments as $comment) {
        if (!empty($elements[$comment['image_id']]['name'])) {
            $name = $elements[$comment['image_id']]['name'];
        } else {
            $name = get_name_from_file($elements[$comment['image_id']]['file']);
        }
        // source of the thumbnail picture
        $thumbnail_src = get_thumbnail_url($elements[$comment['image_id']]);
        // link to the full size picture
        $url = make_picture_url(
            array('category' => $categories[ $comment['category_id'] ],
                'image_id' => $comment['image_id'],
                'image_file' => $elements[$comment['image_id']]['file'],
                )
            );

        $author = $comment['author'];
        if (empty($comment['author'])) {
            $author = l10n('guest');
        }
        // Dimensions de la miniature
        $thumb_size = '';
        $size = @getimagesize(get_thumbnail_path($elements[$comment['image_id']]));
        if ($size[0] > $max_width) $max_width = $size[0];

        if (($size[0] >= $size[1]) || (empty($conf_comonindex[3])) and (!empty($conf_comonindex[2])) and ($size[0] > $conf_comonindex[2]))
            $thumb_size = 'width:' . $conf_comonindex[2] . 'px; height:' . intval($conf_comonindex[2] * $size[1] / $size[0]) . 'px;';

        if (($size[0] < $size[1]) || (empty($conf_comonindex[2])) and (!empty($conf_comonindex[3])) and ($size[1] > $conf_comonindex[3]))
            $thumb_size = 'width:' . intval($conf_comonindex[3] * $size[0] / $size[1]) . 'px; height:' . $conf_comonindex[3] . 'px;';

        $template->assign_block_vars('comment',
            array('U_PICTURE' => $url,
                'TN_SRC' => $thumbnail_src,
                'THUMB_SIZE' => $thumb_size,
                'ALT' => $name,
                'AUTHOR' => trigger_event('render_comment_author', $author),
                'DATE' => format_date($comment['date'], 'mysql_datetime', true),
                'CONTENT' => trigger_event('render_comment_content', $comment['content']),));
        // Boutons d'admin
        if (is_admin() and ($conf_comonindex[1] == 'on')) {
            $url = PHPWG_ROOT_PATH . 'index.php' . get_query_string_diff(array('delete', 'validate'));
            $template->assign_block_vars('comment.action_delete',
                array('U_DELETE' => add_url_params($url,
                        array('delete' => $comment['comment_id'])
                        ),
                    ));
            if ($comment['validated'] != 'true') {
                $template->assign_block_vars('comment.action_validate',
                    array('U_VALIDATE' => add_url_params($url,
                            array('validate' => $comment['comment_id'])
                            ),
                        ));
            }
        }
    }
    // Decalage du cadre commentaire par rapport a la miniature
    if (!empty($conf_comonindex[2])) $max_width = $conf_comonindex[2];
    $template->assign_vars(array('DECAL' => ($max_width + $conf_comonindex[4]) . 'px',));
    // Nombres de cadres par ligne
    if ($conf_comonindex[6] != 'default') {
        switch ($conf_comonindex[6]) {
            case 1: $pourcentage = 99.9;
                break;
            case 2: $pourcentage = 49.9;
                break;
            case 3: $pourcentage = 33.3;
                break;
            case 4: $pourcentage = 24.9;
                break;
        }
        $template->assign_vars(array('NB_CADRES' => 'style="width:' . $pourcentage . '%;"'));
    }
    // Taille des cadres
    if (!empty($conf_comonindex[7])) $template->assign_vars(array('TAILLE_CADRES' => 'style="height:' . $conf_comonindex[7] . 'px;"'));
}

// Emplacement du bloc
if (isset($im_priority)) {
    $insert_before = $im_priority['ComOnIndex'] < $im_priority['Categories'] ? '<div class="titrePage">' : '</div> <!-- content -->';
} else {
    $insert_before = '</div> <!-- content -->';
}
$template->loadfile('index');
$template->uncompiled_code['index'] = str_replace($insert_before, '{COMONINDEX_CONTENT}' . $insert_before, $template->uncompiled_code['index']);

$template->set_filenames(array('comonindex' => COMONINDEX_PATH . 'template/comonindex_' . $conf_comonindex[5] . '.tpl',));
$template->assign_var_from_handle('COMONINDEX_CONTENT', 'comonindex');

?>